<!DOCTYPE html>
<html lang="en">

<head>
    <title>WebXR Proof of Concept</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <link type="text/css" rel="stylesheet" href="style.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/three.js/r126/three.js" crossorigin="anonymous"></script>
</head>

<body>
    <script type="module">
        import { ARButton } from 'https://unpkg.com/three@0.126.0/examples/jsm/webxr/ARButton.js';

        let camera, scene, renderer;
        let mesh;

        init();
        animate();

        function init() {
            const container = document.createElement('div');
            document.body.appendChild(container);

            // #1 Create the scene
            // Documentation: https://threejs.org/docs/#manual/en/introduction/Creating-a-scene
            scene = new THREE.Scene();

            // #2 Create the camera
            // Documentation: https://threejs.org/docs/#api/en/cameras/PerspectiveCamera
            camera = new THREE.PerspectiveCamera(70, window.innerWidth / window.innerHeight, 0.01, 40);

            // #3 Pick a three.js renderer
            // Documentation: https://threejs.org/docs/#api/en/renderers/WebGLRenderer
            renderer = new THREE.WebGLRenderer({ antialias: true, alpha: true });
            renderer.setPixelRatio(window.devicePixelRatio);
            renderer.setSize(window.innerWidth, window.innerHeight);
            // Enable the renderer for WebXR
            renderer.xr.enabled = true; // New!
            container.appendChild(renderer.domElement);

            // #4 Add lights to the scene (optional)
            var light = new THREE.HemisphereLight(0xffffff, 0xbbbbff, 1);
            light.position.set(0.5, 1, 0.25);
            scene.add(light);

            // #5 Add a polygon geometry to the scene (optional)
            // Documentation: https://threejs.org/docs/?q=boxgeo#api/en/geometries/BoxGeometry
            const geometry = new THREE.IcosahedronGeometry(0.1, 1);
            const material = new THREE.MeshPhongMaterial({
                color: new THREE.Color("rgb(226,35,213)"),
                shininess: 6,
                flatShading: true,
                transparent: 1,
                opacity: 0.8
            });
            mesh = new THREE.Mesh(geometry, material);
            mesh.position.set(0, 0, -0.5);
            scene.add(mesh);

            // Add the AR button to the body of the DOM
            document.body.appendChild(ARButton.createButton(renderer));

            window.addEventListener('resize', onWindowResize, false);
        }

        function onWindowResize() {
            // Resize window for different devices
            camera.aspect = window.innerWidth / window.innerHeight;
            camera.updateProjectionMatrix();

            renderer.setSize(window.innerWidth, window.innerHeight);
        }

        function animate() {
            // Setup an animation loop for the renderer.
            // The animation loop runs about 60 times/frames per second (default).
            renderer.setAnimationLoop(render);
        }

        function render() {
            // Render all 3D components in the scene and how they will get shown on screen.
            mesh.rotation.x += 0.01;
            mesh.rotation.y += 0.01;
            renderer.render(scene, camera);
        }

    </script>
</body>

</html>